Macro Solid Sweep/fr: Difference between revisions

From FreeCAD Documentation
m (Created page with "=== Utilisation === * Créer deux éléments 2D, un pour la section et l'autre pour la trajectoire, selon les types listés ci-dessous. * Sélectionner soit dans l'arborescen...")
Line 7: Line 7:
[[File:Solid_sweep.png‎|500px|Quelques exemples de balayages utilisant une même section oblongue et trois types de trajectoires.]]
[[File:Solid_sweep.png‎|500px|Quelques exemples de balayages utilisant une même section oblongue et trois types de trajectoires.]]


=== How to use ===
=== Utilisation ===

* Create two 2D elements, one for the section and one for the trajectory, of the types listed below.
* Créer deux éléments 2D, un pour la section et l'autre pour la trajectoire, selon les types listés ci-dessous.
* Select, either in the Project tree or in the 3D view, first the trajectory, then the profile. The order is important!
* Sélectionner soit dans l'arborescence de projet, soit dans la vue 3D, en premier lieu la trajectoire, et ensuite la section. Attention, l'ordre de sélection est important!
* Open the Macro manager, select the macro and click "Execute".
* Ouvrir le gestionnaire Macro, sélectionner la macro et cliquer sur « Lancer ».
* A '''Sweep''' object will be created in the Project tree.
* Un objet '''Balayage''' sera créé dans l'arborescence de projet.


=== Supported 2D elements ===
=== Supported 2D elements ===

Revision as of 10:23, 26 December 2013

File:Text-x-python Balayage solide

Description
Créé un solide en balayant un profil le long d'une trajectoire.

Auteur: Normandc
Auteur
Normandc
Téléchargement
None
Liens
Version Macro
1.0
Dernière modification
None
Version(s) FreeCAD
None
Raccourci clavier
None
Voir aussi
None

Cette macro créé un solide en balayant un profil le long d'une trajectoire, les deux éléments ayant précédemment été sélectionnés dans la vue 3D. Les éléments 2D peuvent être créés à l'aide des outils existants de l'interface graphique de FreeCAD.

Il est à noter que le solide généré ne sera pas paramétrique. Si vous décidez de modifier le profil ou la trajectoire, vous devrez exécuter la macro à nouveau.

Quelques exemples de balayages utilisant une même section oblongue et trois types de trajectoires.

Utilisation

  • Créer deux éléments 2D, un pour la section et l'autre pour la trajectoire, selon les types listés ci-dessous.
  • Sélectionner soit dans l'arborescence de projet, soit dans la vue 3D, en premier lieu la trajectoire, et ensuite la section. Attention, l'ordre de sélection est important!
  • Ouvrir le gestionnaire Macro, sélectionner la macro et cliquer sur « Lancer ».
  • Un objet Balayage sera créé dans l'arborescence de projet.

Supported 2D elements

  • Wires
  • Sketches
  • Draft BSpline
  • 2D primitives from the Parametric → Create Primitives... menu (circle, helix)

Tips

  • The section has to be a closed profile or the result will not be a solid.
  • The section does not need to be located on the trajectory, but it's preferable that it be normal (perpendicular) to the trajectory.
  • The trajectory can either be an open or closed profile (circle, or line and arc segments) but all elements need to be tangent or the resulting shape will be unexpected. For example, a trajectory with straight corners like a rectangle will not produce a solid.
  • If the solid gets twisted, edit the macro to change the isFrenet value to 0 (zero) and try again.
  • Setting the makeSolid variable to 0 (zero) in the macro will produce a set of surfaces with open ends.

The script

import Part, FreeCAD, math, PartGui, FreeCADGui
from FreeCAD import Base

# pick selected objects, where 1st selection is the trajectory and the 2nd is the section to sweep
s = FreeCADGui.Selection.getSelection()
try:
    shape1=s[0].Shape
    shape2=s[1].Shape
except:
    print "Wrong selection"

traj = Part.Wire([shape1])
section = Part.Wire([shape2])

# create a Part object into the active document
myObject=App.ActiveDocument.addObject("Part::Feature","Sweep")

makeSolid = 1
isFrenet = 1

# Create the 3D shape and set it to the Part object
Sweep = Part.Wire(traj).makePipeShell([section],makeSolid,isFrenet)
myObject.Shape = Sweep</pre>

Credits

Thanks to Wmayer for his help in writing this script.

Two examples of uses can be found in this forum topic, along with download links to the FCStd files. Using a helix as trajectory, a solid sweep can be used to create a bolt thread.

Other languages: